diff --git a/packages/visualgst/Inspector/View/GtkObjectInspectorView.st b/packages/visualgst/Inspector/View/GtkObjectInspectorView.st
new file mode 100644
index 0000000..1e34763
--- /dev/null
+++ b/packages/visualgst/Inspector/View/GtkObjectInspectorView.st
@@ -0,0 +1,88 @@
+"======================================================================
+|
+| GtkObjectInspectorView class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+Object subclass: GtkObjectInspectorView [
+    | object model |
+
+    GtkObjectInspectorView class >> openOn: anObject [
+	<category: 'instance creation'>
+
+	^ (super new)
+	    object: anObject;
+	    yourself
+    ]
+
+    object [
+	<category: 'accessing'>
+	
+	^ object
+    ]
+
+    object: anObject [
+	<category: 'accessing'>
+
+	object := anObject.
+    ]
+
+    do: aBlock [ 
+	<category: 'iterating'>
+
+	aBlock value: 'self'.
+        self object class allInstVarNames do: aBlock
+    ]
+
+    values [
+	<category: 'accessing'>
+
+	^Array streamContents: [:s | self do: [:value | s nextPut: value]]
+    ]
+
+    selectedValue: aString [
+	<category: 'item selection'>
+
+	| iter string instVar |
+        ^ aString = 'self'
+            ifTrue: [ self object ]
+            ifFalse: [ self object
+			instVarNamed: aString ]
+    ]
+
+    canDive [
+	<category: 'testing'>
+
+	^ true
+    ]
+]
+
diff --git a/packages/visualgst/Inspector/View/GtkSequenceableCollectionInspectorView.st b/packages/visualgst/Inspector/View/GtkSequenceableCollectionInspectorView.st
new file mode 100644
index 0000000..9e92f05
--- /dev/null
+++ b/packages/visualgst/Inspector/View/GtkSequenceableCollectionInspectorView.st
@@ -0,0 +1,51 @@
+"======================================================================
+|
+| GtkSequenceableCollectionInspectorView class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+GtkObjectInspectorView subclass: GtkSequenceableCollectionInspectorView [
+
+    do: aBlock [
+	super do: aBlock.
+	1 to: self object size do: [ :each | aBlock value: each ]
+    ]
+
+    selectedValue: aString [
+	<category: 'events'>
+
+	^ aString asNumber = 0 
+	    ifTrue: [ super selectedValue: aString ]
+	    ifFalse: [ self object at: aString asNumber ]
+    ]
+]
+
diff --git a/packages/visualgst/Inspector/View/GtkSetInspectorView.st b/packages/visualgst/Inspector/View/GtkSetInspectorView.st
new file mode 100644
index 0000000..fdfef99
--- /dev/null
+++ b/packages/visualgst/Inspector/View/GtkSetInspectorView.st
@@ -0,0 +1,53 @@
+"======================================================================
+|
+| GtkSetInspectorView class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+GtkObjectInspectorView subclass: GtkSetInspectorView [
+
+    do: aBlock [
+	<category: 'accessing'>
+
+	super do: aBlock.
+        self object do: aBlock
+    ]
+
+    selectedValue: anObject [
+        <category: 'events'>
+
+        ^ (self object includes: anObject)
+            ifFalse: [ super selectedValue: anObject ]
+            ifTrue: [ anObject ]
+    ]
+]
+
diff --git a/packages/visualgst/Menus/HistorySelectionMenus.st b/packages/visualgst/Menus/HistorySelectionMenus.st
new file mode 100644
index 0000000..c786882
--- /dev/null
+++ b/packages/visualgst/Menus/HistorySelectionMenus.st
@@ -0,0 +1,43 @@
+"======================================================================
+|
+| HistoryMenus class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+MenuBuilder subclass: HistorySelectionMenus [
+
+    HistorySelectionMenus class >> menus [
+
+	^ { HistoryBackCommand.
+            HistoryForwardCommand }
+    ]
+]
diff --git a/packages/visualgst/SUnit/GtkClassSUnitWidget.st b/packages/visualgst/SUnit/GtkClassSUnitWidget.st
new file mode 100644
index 0000000..587a054
--- /dev/null
+++ b/packages/visualgst/SUnit/GtkClassSUnitWidget.st
@@ -0,0 +1,106 @@
+"======================================================================
+|
+| GtkClassSUnitWidget class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+GtkCategorizedClassWidget subclass: GtkClassSUnitWidget [
+
+    buildTreeView [
+        <category: 'user interface'>
+
+        super buildTreeView.
+        widget multipleSelection.
+    ]
+
+    addToModel: aClass [
+
+        "(aClass superclass environment == self namespace and: [ (aClass superclass category = self category or: [ self category isEmpty ]) and: [ aClass superclass ~~ Smalltalk.TestCase ] ]) 
+                    ifFalse: [ model append: aClass class ]
+                    ifTrue: [ model append: aClass class parent: aClass superclass class ]"
+    ]
+
+    root [
+	<category: 'accessing'>
+
+        ^ Smalltalk.TestCase
+    ]
+
+    selectionMode [
+        <category: 'accessing'>
+
+        ^ GTK.Gtk gtkSelectionMultiple
+    ]
+
+    allClassNames [
+        <category: 'accessing'>
+
+	| classes names |
+	classes := self selectedClasses.
+	names := classes collect: [ :each | each name asString ].
+	^ names fold: [ :a :b | a, ', ', b ]
+    ]
+
+    hasSelectedClass [
+        <category: 'testing'>
+
+        ^ widget hasSelection
+    ]
+
+    selectedClass [
+        <category: 'accessing'>
+
+	^ self selectedClasses first
+    ]
+
+    selectedClasses [
+        <category: 'accessing'>
+
+	self hasSelectedClass ifFalse: [ self error: 'Nothing is selected' ].
+	^ widget selection collect: [:each| each asClass]
+    ]
+
+    recategorizedEvent: anEvent [
+        <category: 'model event'>
+
+        (anEvent item inheritsFrom: TestCase) ifFalse: [ ^ self ].
+        super recategorizedEvent: anEvent
+    ]
+
+    addEvent: anEvent [
+        <category: 'model event'>
+
+        (anEvent item inheritsFrom: TestCase) ifFalse: [ ^ self ].
+        super addEvent: anEvent
+    ]
+]
+
diff --git a/packages/visualgst/SUnit/GtkMethodSUnitWidget.st b/packages/visualgst/SUnit/GtkMethodSUnitWidget.st
new file mode 100644
index 0000000..bf1876d
--- /dev/null
+++ b/packages/visualgst/SUnit/GtkMethodSUnitWidget.st
@@ -0,0 +1,51 @@
+"======================================================================
+|
+| GtkMethodSUnitWidget class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+GtkMethodWidget subclass: GtkMethodSUnitWidget [
+
+    category: aString [
+        <category: 'accessing'>
+
+        category := aString.
+        self classOrMeta methodDictionary ifNil: [
+                self clear.
+                ^ self].
+        widget
+            item: ((self classOrMeta methodDictionary select: [ :each | self category = '*' or: [ each methodCategory = self category and: [ each selector matchRegex: 'test' from: 1 to: 4 ] ] ])
+                                                                                                    asArray sort: [ :a :b | a selector <= b selector ]);
+            refresh
+    ]
+]
+
diff --git a/packages/visualgst/SUnit/GtkSUnit.st b/packages/visualgst/SUnit/GtkSUnit.st
index 1636b6b..4bd167a 100644
--- a/packages/visualgst/SUnit/GtkSUnit.st
+++ b/packages/visualgst/SUnit/GtkSUnit.st
@@ -34,6 +34,7 @@
 ======================================================================"
 
 GtkBrowsingTool subclass: GtkSUnit [
+
     | namespaceWidget classWidget methodWidget sourceCodeWidget successfullWidget failedWidget errorWidget namespace class state |
 
     accelPath [
@@ -77,47 +78,35 @@ GtkBrowsingTool subclass: GtkSUnit [
     buildNamespaceAndClassWidget [
 	<category: 'user interface'>
 
-	^ (GTK.GtkHPaned new)
-	    pack1: self buildNamespaceWidget resize: true shrink: false;
-	    pack2: self buildClassWidget resize: true shrink: false;
-	    yourself
+	^ HPaned with:self buildNamespaceWidget with: self buildClassWidget
     ]
 
     buildNamespaceAndClassAndMethodWidget [
 	<category: 'user interface'>
 
-	^ (GTK.GtkHPaned new)
-	    pack1: self buildNamespaceAndClassWidget resize: true shrink: false;
-	    pack2: self buildMethodWidget resize: true shrink: false;
-	    yourself
+	^ HPaned with: self buildNamespaceAndClassWidget with: self buildMethodWidget
     ]
 
     buildMiniBrowser [
 	<category: 'user interface'>
 
-	^ (GTK.GtkVPaned new)
-	    pack1: self buildNamespaceAndClassAndMethodWidget resize: true shrink: false;
-	    pack2: self buildSourceCodeWidget resize: true shrink: false;
-	    yourself
+	^ VPaned with: self buildNamespaceAndClassAndMethodWidget with: self buildSourceCodeWidget
     ]
 
     buildResultWidget [
 	<category: 'user interface'>
 
-	^ GTK.GtkNotebook new
-	    appendPage: self buildSuccesfullWidget tabLabel: (GTK.GtkLabel new: 'Successful Tests');
-	    appendPage: self buildFailedWidget tabLabel: (GTK.GtkLabel new: 'Failed Tests');
-	    appendPage: self buildErrorWidget tabLabel: (GTK.GtkLabel new: 'Errors Tests');
+	^ Notebook new
+	    addPermanentWidget: self buildSuccesfullWidget label: 'Successful Tests';
+	    addPermanentWidget: self buildFailedWidget label: 'Failed Tests';
+	    addPermanentWidget: self buildErrorWidget label: 'Errors Tests';
 	    yourself
     ]
 
     buildCentralWidget [
         <category: 'intialize-release'>
 
-	^ (GTK.GtkVPaned new)
-	    pack1: self buildMiniBrowser resize: true shrink: false;
-	    pack2: self buildResultWidget resize: true shrink: false;
-	    yourself
+	^ VPaned with: self buildMiniBrowser with: self buildResultWidget
     ]
 
     initialize [
@@ -145,68 +134,53 @@ GtkBrowsingTool subclass: GtkSUnit [
     buildNamespaceWidget [
 	<category: 'user interface'>
 
-	namespaceWidget := GtkCategorizedNamespaceWidget showAll 
+	^ namespaceWidget := GtkCategorizedNamespaceWidget new 
 				whenSelectionChangedSend: #onNamespaceChanged to: self;
 				yourself.
-	^ namespaceWidget mainWidget
     ]
 
     buildClassWidget [
 	<category: 'user interface'>
 
-	classWidget := GtkClassSUnitWidget showAll 
+	^ classWidget := GtkClassSUnitWidget new
 				selectionMode: GTK.Gtk gtkSelectionMultiple;
 				whenSelectionChangedSend: #onClassChanged to: self;
 				yourself.
-	^ classWidget mainWidget
     ]
 
     buildMethodWidget [
 	<category: 'user interface'>
 
-	methodWidget := GtkMethodSUnitWidget showAll
+	^ methodWidget := GtkMethodSUnitWidget new
 				whenSelectionChangedSend: #onMethodChanged to: self;
                                 yourself.
-        ^ methodWidget mainWidget
     ]
 
     buildSourceCodeWidget [
         <category: 'user interface'>
 
-        sourceCodeWidget := GtkSourceCodeWidget showAll.
+        sourceCodeWidget := GtkSourceCodeWidget new.
 	sourceCodeWidget parentWindow: window.
 	sourceCodeWidget browser: self.
-        ^ sourceCodeWidget mainWidget
+        ^ sourceCodeWidget
     ]
 
     buildSuccesfullWidget [
 	<category: 'user interface'>
 
-	successfullWidget := GtkSUnitResult new
-				initialize;
-				yourself.
-
-	^ successfullWidget mainWidget
+	^ successfullWidget := GtkSUnitResult new
     ]
 
     buildFailedWidget [
 	<category: 'user interface'>
 
-	failedWidget := GtkSUnitResult new
-				initialize;
-				yourself.
-
-	^ failedWidget mainWidget
+	^ failedWidget := GtkSUnitResult new
     ]
 
     buildErrorWidget  [
 	<category: 'user interface'>
 
-	errorWidget := GtkSUnitResult new
-				initialize;
-				yourself.
-
-	^ errorWidget mainWidget
+	^ errorWidget := GtkSUnitResult new
     ]
 
     onNamespaceChanged [
diff --git a/packages/visualgst/SUnit/GtkSUnitResultWidget.st b/packages/visualgst/SUnit/GtkSUnitResultWidget.st
index ba616e4..d6a9de3 100644
--- a/packages/visualgst/SUnit/GtkSUnitResultWidget.st
+++ b/packages/visualgst/SUnit/GtkSUnitResultWidget.st
@@ -33,43 +33,35 @@
 |
 ======================================================================"
 
-GtkConcreteWidget subclass: GtkSUnitResult [
-    | model resultTree results |
+Compoment subclass: GtkSUnitResult [
+
+    | results |
+
     initialize [
 	<category: 'initialization'>
 
-	self mainWidget: self buildTreeView
+	self buildTreeView
     ]
 
     buildTreeView [
         <category: 'user interface'>
 
-        resultTree := (GTK.GtkTreeView newWithTextColumn: self model title: 'Results')
-                            connectSignal: 'button-press-event' to: self selector: #'onPress:event:' userData: nil;
-                            yourself.
-        ^ GTK.GtkScrolledWindow withChild: resultTree
-    ]
-
-    model [
-        <category: 'model'>
-
-        ^ model ifNil: [
-            model := GTK.GtkTreeStore new: 2 varargs: {GTK.GValue gTypeString. GLib.GType oopType} ]
+        self widget: (List column: {{GtkColumnTextType title: 'Results'}} contents: [ :each | { each displayString } ]).
     ]
 
     clearModel [
 	<category: 'model'>
 
-	self model clear
+        widget clear
     ]
 
     results: aSet [
 	<category: 'accessing'>
 
-	self clearModel.
 	results := aSet.
-	results do: [ :each |
-	    self model appendItem: {each displayString. each} ]
+        widget
+            item: aSet;
+            refresh
     ]
 
     popupMenuOn: aGtkWidget menu: aGtkMenu [
@@ -94,19 +86,6 @@ GtkConcreteWidget subclass: GtkSUnitResult [
         aGtkMenu append: menuitem.
     ]
 
-    onPress: aGtkWidget event: aGdkEvent [
-	<category: 'events'>
-	| aGdkButtonEvent menu |
-        aGdkButtonEvent := aGdkEvent castTo: GTK.GdkEventButton type.
-        aGdkButtonEvent button value = 3 ifFalse: [ ^ false ].
-        menu := GTK.GtkMenu new.
-	self popupMenuOn: aGtkWidget menu: menu.
-        menu attachToWidget: resultTree detacher: nil.
-        menu showAll.
-        menu popup: nil parentMenuItem: nil func: nil data: nil button: 3 activateTime: aGdkButtonEvent time value.
-        ^ true
-    ]
-
     debugTest [
 	<category: 'event'>
 	
@@ -116,14 +95,14 @@ GtkConcreteWidget subclass: GtkSUnitResult [
     hasSelectedMethod [
         <category: 'testing'>
 
-        ^ resultTree hasSelectedItem
+        ^ widget hasSelection
     ]
 
     state [
         <category: 'state'>
-        resultTree hasSelectedItem ifTrue: [
+        widget hasSelection ifTrue: [
             ^MethodState on: self selectedResult class >> self selectedResult selector ].
-        ^BrowserState new
+        ^ BrowserState new
     ]
 	
     selectedMethodSymbol [
@@ -142,9 +121,8 @@ GtkConcreteWidget subclass: GtkSUnitResult [
     selectedResult [
         <category: 'accessing'>
 
-	| iter |
-        (iter := resultTree selectedIter) ifNil: [ self error: 'Nothing is selected' ].
-        ^ self model getOop: iter column: 1
+        widget hasSelection ifNil: [ self error: 'Nothing is selected' ].
+        ^ widget selection
     ]
 
     browseImplementors [
diff --git a/packages/visualgst/StBrowser/GtkCategorizedClassWidget.st b/packages/visualgst/StBrowser/GtkCategorizedClassWidget.st
index d05d9dd..c1c3b6c 100644
--- a/packages/visualgst/StBrowser/GtkCategorizedClassWidget.st
+++ b/packages/visualgst/StBrowser/GtkCategorizedClassWidget.st
@@ -41,14 +41,14 @@ Smalltalk.String extend [
     ]
 ]
 
-GtkConcreteWidget subclass: GtkCategorizedClassWidget [
-    | classesTree column model namespace category |
+Compoment subclass: GtkCategorizedClassWidget [
+
+    | column namespace category |
 
     GtkCategorizedClassWidget >> on: aNamespace [
 	<category: 'instance creation'>
 
-	^ (self new)
-	    initialize;
+	^ self new
 	    namespace: aNamespace;
 	    yourself
     ]
@@ -58,7 +58,7 @@ GtkConcreteWidget subclass: GtkCategorizedClassWidget [
 
 	self
 	    category: '';
-	    mainWidget: self buildTreeView;
+	    buildTreeView;
 	    registerNotifier
     ]
 
@@ -103,8 +103,8 @@ GtkConcreteWidget subclass: GtkCategorizedClassWidget [
         self
             category: aString;
             namespace: aNamespace.
-	model refresh.
-	classesTree treeView expandAll
+	widget refresh.
+	widget expandAll
     ]
 
     appendClass: aClass to: anArray [
@@ -130,36 +130,35 @@ GtkConcreteWidget subclass: GtkCategorizedClassWidget [
     clear [
         <category: 'accessing'>
 
-        model clear
+        widget clear
     ]
 
     buildTreeView [
 	<category: 'user interface'>
    
-        classesTree := GtkScrollTreeWidget createTreeWithModel: {{GtkColumnTextType title: 'Classes'}}.
-        classesTree connectToWhenPopupMenu: (ClassMenus on: self).
-        classesTree treeView getSelection setMode: self selectionMode.
-        (model := GtkTreeModel on: classesTree treeView getModel)
-					item: self root;
-					childrenBlock: [ :each | | col | 
-							    col := SortedCollection sortBlock: [ :a :b | a asClass name <= b asClass name ]. 
-							    each subclassesDo: [ :subclasses | self appendClass: subclasses to: col ]. 
-							    col ];
-                                        contentsBlock: [ :each | {each asClass name asString, ' '} ].
-        ^ classesTree mainWidget
+        self widget: (Tree 
+                        column: {{GtkColumnTextType title: 'Classes'}}
+			children: [ :each | | col | 
+					col := SortedCollection sortBlock: [ :a :b | a asClass name <= b asClass name ]. 
+					each subclassesDo: [ :subclasses | self appendClass: subclasses to: col ]. 
+					col ]
+                        contents: [ :each | {each asClass name asString, ' '} ]).
+        widget
+            popupMenu: (ClassMenus on: self);
+            singleSelection;
+            item: self root.
     ]
 
     whenSelectionChangedSend: aSelector to: anObject [
 	<category: 'events'>
 
-	classesTree treeView getSelection
-	    connectSignal: 'changed' to: anObject selector: aSelector
+	widget whenSelectionChangedSend: aSelector to: anObject
     ]
 
     selectionMode: aSelectionMode [
 	<category: 'user interface'>
 
-	classesTree treeView getSelection setMode: aSelectionMode.
+	"widget treeView getSelection setMode: aSelectionMode."
     ]
 
     selectedNamespace [
@@ -177,7 +176,7 @@ GtkConcreteWidget subclass: GtkCategorizedClassWidget [
     hasSelectedClass [
 	<category: 'testing'>
 
-	^ classesTree treeView hasSelectedItem
+	^ widget hasSelection
     ]
 
     state [
@@ -194,55 +193,55 @@ GtkConcreteWidget subclass: GtkCategorizedClassWidget [
 	<category: 'accessing'>
 
 	self hasSelectedClass ifFalse: [ self error: 'nothing is selected' ].
-	^ classesTree treeView selection asClass
+	^ widget selection asClass
     ]
 
     selectAClass: aClass [
 	<category: 'item selection'>
 
-	classesTree treeView select: aClass
+	widget select: aClass
     ]
 
     addToModel: aClass [
 
-	(model includes: aClass class) ifTrue: [ ^ self ].
+	"(model includes: aClass class) ifTrue: [ ^ self ].
 	(aClass superclass environment == self namespace and: [ aClass superclass category = self category or: [ self category isEmpty ] ]) 
 				    ifFalse: [ model append: aClass class ] 
-				    ifTrue: [ model append: aClass class parent: aClass superclass class ]
+				    ifTrue: [ model append: aClass class parent: aClass superclass class ]"
     ]
 
     addEvent: anEvent [
         <category: 'model event'>
 
-        anEvent item environment == self namespace ifFalse: [ ^ self ].
+        "anEvent item environment == self namespace ifFalse: [ ^ self ].
         (anEvent item category = self category or: [ self category isEmpty ]) ifFalse: [ ^ self ].
-	self addToModel: anEvent item
+	self addToModel: anEvent item"
     ]
 
     removeEvent: anEvent [
         <category: 'model event'>
 
-        anEvent item environment == self namespace ifFalse: [ ^ self ].
+        "anEvent item environment == self namespace ifFalse: [ ^ self ].
         (anEvent item category = self category or: [ self category isEmpty ]) ifFalse: [ ^ self ].
-        model remove: anEvent item class
+        model remove: anEvent item class"
     ]
 
     modificationEvent: anEvent [
         <category: 'model event'>
 
-        (anEvent item environment == self namespace or: [ anEvent isSuperclassModified not ]) ifFalse: [ ^ self ].
+        "(anEvent item environment == self namespace or: [ anEvent isSuperclassModified not ]) ifFalse: [ ^ self ].
         (anEvent oldItem category = self category or: [ anEvent oldItem category isNil and: [ self category isEmpty ] ])
 		    ifTrue: [ model remove: anEvent item class ifAbsent: [ nil ] ].
         (anEvent item category = self category or: [ anEvent item category isNil and: [ self category isEmpty ] ]) 
-		    ifTrue: [ self addToModel: anEvent item ]
+		    ifTrue: [ self addToModel: anEvent item ]"
     ]
 
     recategorizedEvent: anEvent [
         <category: 'model event'>
 
-        anEvent item environment == self namespace ifFalse: [ ^ self ].
+        "anEvent item environment == self namespace ifFalse: [ ^ self ].
         (anEvent oldCategory = self category or: [ anEvent oldCategory isNil and: [ self category isEmpty and: [ model includes: anEvent item ] ] ]) ifTrue: [ model remove: anEvent item class ].
-        (anEvent item category = self category or: [ anEvent item category isNil and: [ self category isEmpty ] ]) ifTrue: [ self addToModel: anEvent item ]
+        (anEvent item category = self category or: [ anEvent item category isNil and: [ self category isEmpty ] ]) ifTrue: [ self addToModel: anEvent item ]"
     ]
 ]
 
